(function() {
	'use strict';

	angular.module('abstractpapers').directive('abstractpaperlist', function(Pagination, $ionicScrollDelegate) {
		return {
			restrict : 'E',
			transclude : true,
			scope : {
				data : '=',
				paginated : '='
			},
			link : function(scope) {
				scope.elements = [];

				scope.$watch('data', function() {
					scope.elements = scope.data;
					scope.limit = 50;
					if (scope.paginated) {
						scope.pagination = Pagination.getNew(scope.limit);
						scope.start = scope.pagination.page * scope.limit;

						scope.pagination.numPages = Math.ceil(scope.elements.length / scope.limit);
					} else {
						scope.start = 0;
						scope.limit = scope.elements.length;
					}
				});
				scope.previous = function() {
					scope.pagination.prevPage();
					scope.start = scope.pagination.page * scope.limit;
					$ionicScrollDelegate.scrollTop();
				};
				scope.next = function() {
					scope.pagination.nextPage();
					scope.start = scope.pagination.page * scope.limit;
					$ionicScrollDelegate.scrollTop();
				};

			},
			templateUrl : 'modules/abstractpaper/directives/abstractPaperList/list.html'
		};
	});

})();
