'use strict';

angular.module('banners').factory('Banners', function($common, $database) {
	var Banner = $common.model();
	Banner.tableName = 'banners';
	Banner.fields = {
		'id' : 'text primary key',
		'target' : 'text',
		'logo' : 'text',
		'type' : 'text',

	};

	Banner.all = function() {
		var query = 'SELECT * from banners';
		return $database.getItems(query, [], Banner);
	};

	return Banner;
}).factory('poollingFactory', function($timeout) {

	var timeIntervalInSec = 3;

	function callFnOnInterval(fn, timeInterval) {

		var promise = $timeout(fn, 1000 * timeIntervalInSec);

		return promise.then(function() {
			callFnOnInterval(fn, timeInterval);
		});
	}

	return {
		callFnOnInterval : callFnOnInterval
	};
});

