(function() {
  'use strict';
  angular.module('chat')
    .directive('dmsChaticon', function($http, $settings, User) {
      return {
        restrict: 'E',
        scope: {
          chat: '=chat'
        },
        link: function(scope) {
          scope.$watch('chat', function() {
            if (scope.chat && User.chat) {
              var url = $settings.apiHost + '/conference/' + $settings.conferenceId + '/chat/users/' + scope.chat + '/';
              $http.get(url)
                .then(function(result) {
                  scope.chatuser = result.data;
                });
            }
          });
        },
        templateUrl: 'modules/chat/views/chaticon.html',
        controller: function($scope, $location) {
          $scope.addChat = function(chatuser) {
            $location.path('/app/chat/' + chatuser.name + '/' + chatuser.id);
          };
        }
      };
    });
})();
