'use strict';

angular.module('common.basecontrollers', []).factory('$baseControllers', function($pubsub) {
	var baseControllerFactory = {};

	baseControllerFactory.applyDetailController = function(scope, stateParams, factory, options) {
		options = options || {};
		var scopeField = options.scopeField || 'item';
		scope[scopeField] = {};
		var id = stateParams.id;
		factory.get(id, options).then(function(item) {
			scope[scopeField] = item;
		});
	};

	baseControllerFactory.applyListController = function(scope, factory, options) {
		options = options || {};
		var scopeField = options.scopeField || 'items';
		var getAll = function() {
			factory.all().then(function(items) {
				scope[scopeField] = items;
			});
		};

		scope[scopeField] = [];
		getAll();
		$pubsub.subscribe(factory.tableName, getAll);
	};

	return baseControllerFactory;
});
