'use strict';

angular.module('database.websql', []).factory('$websqlDriver', function($q, $settings) {
  return {
    getDB: function() {
      if (!this.db) {
        this.db = openDatabase('kongressApp' + $settings.conferenceId, '1.0', 'testing db', 2 * 1024 * 1024);
      }
      return this.db;
    },

    execute: function(query, params) {
      var db = this.getDB();
      var deferred = $q.defer();
      db.transaction(function(transaction) {
        transaction.executeSql(query, params, function(transaction, result) {
          deferred.resolve(result);
        });
      });
      return deferred.promise;
    },
    massExecute: function(operations) {
      var db = this.getDB();
      var transactionPromise = $q.defer();
      var rowPromises = [];
      db.transaction(function(transaction) {
        operations.forEach(function(operation) {
          var rowPromise = $q.defer();
          rowPromises.push(rowPromise);
          transaction.executeSql(operation.query, operation.params, function(transaction, result) {
            rowPromise.resolve(result);
          });
        });
        $q.all(rowPromises).then(function() {
          transactionPromise.resolve('done');
        });
      });
      return transactionPromise.promise;
    }
  };
});
