(function() {
	'use strict';

	angular.module('exhibitions').controller('ExhibitionDetailCtrl', function($scope, $stateParams, $exhibitions, $baseControllers, $settings, Features) {
		$scope.shareEnabled = Features.shareFunction;
		$scope.isNative = $settings.isNative;
		$scope.platform = $settings.platform;
		var id = $stateParams.id;
		$scope.item = {};
		$scope.medias = [];
		$scope.tags = [];
		$scope.locations = [];

		$exhibitions.get(id).then(function(exhibition) {
			$scope.headTitle = exhibition.name;

			if (exhibition.locations) {
				exhibition.getLocations().then(function(locations) {
					$scope.locations = locations;
				});
			}
			
			if(exhibition.medias){
				exhibition.getMedias().then(function(medias){
					$scope.medias = medias;
				});
			}
			exhibition.getSponsorLevel().then(function(level) {
				if (level) {
					$scope.level = level.title;
				}
			});

			$scope.item = exhibition;

		});

		$scope.share = function() {
			window.plugins.socialsharing.share('I am visiting ' + $scope.item.name);
		};
	});
})();
