(function() {
  'use strict';

  angular.module('exhibitions')
    .directive('exhibitionlist', function() {
      return {
        restrict: 'E',
        transclude: true,
        scope: {
          data: '=',
        },
        link: function(scope) {

          scope.$watch('data', function() {
            scope.elements = [];
            scope.isAndroid = ionic.Platform.isAndroid();

            if (scope.data) {
              scope.data.forEach(function(element) {
                if (element.locations) {
                  element.getLocations().then(function(locations) {
                    element.location = '';
                    locations.forEach(function(location) {
                      element.location += location.name + ' ';
                    });
                  });
                }
                var baseHeight = (element.logo && element.is_exhibition_list_logo_visible == 'true') ? 140 : 70;
                element.height = (baseHeight + parseInt(element.name.length / 35) * 14);
                scope.elements.push(element);
              });
            }
          });

        },
        templateUrl: 'modules/exhibition/directives/exhibitionlist/exhibition-directive.html'
      };
    });
})();
