(function() {
	'use strict';

	angular.module('exhibitions').factory('$exhibitions', function($common, $database) {
		var Exhibition = $common.model();
		Exhibition.tableName = 'exhibitions';
		Exhibition.fields = {
			'id' : 'text primary key',
			'name' : 'text',
			'description' : 'text',
			'logo' : 'text',
			'email' : 'text',
			'street' : 'text',
			'zip_code' : 'text',
			'city' : 'text',
			'state' : 'text',
			'country' : 'text',
			'phone' : 'text',
			'fax' : 'text',
			'homepage' : 'text',
			'tags' : 'text',
			'locations' : 'text',
			'medias' : 'text',
			'short_name' : 'text',
			'is_sponsor' : 'integer',
			'is_exhibition' : 'integer',
			'is_exhibition_list_logo_visible' : 'integer'
		};

		Exhibition.all = function() {
			var query = 'SELECT * from exhibitions WHERE is_exhibition = "true"';
			return $database.getItems(query, [], Exhibition);
		};
		//customization START dgu2015: gettopexhibitors
    Exhibition.getTopExhibitors = function(){
      var query = 'SELECT * from exhibitions WHERE id IN (\'e2e18144-4869-486f-8434-9cd6d1e0d10b\',\'f2f624d1-29e1-4468-8885-9d9c2ff5fa29\') ORDER BY name';
      return $database.getItems(query, [], Exhibition);
    };
    //customization END dgu2015: gettopexhibitors

		Exhibition.prototype.getTags = function() {
			var query = 'SELECT tags.id, tags.title, tags.color FROM tags WHERE tags.id IN (' + this.tags.split(',').map(JSON.stringify).join(',') + ' )';
			return $database.getItems(query, []);
		};

		Exhibition.prototype.getLocations = function() {
			var query = 'SELECT * FROM locations WHERE locations.id IN (' + this.locations.split(',').map(JSON.stringify).join(',') + ' )';
			return $database.getItems(query, []);
		};

		Exhibition.prototype.getMedias = function() {
			var query = 'SELECT * FROM medias WHERE medias.id IN (' + this.medias.split(',').map(JSON.stringify).join(',') + ')';
			return $database.getItems(query, []);
		};

		Exhibition.prototype.getSponsorLevel = function() {
			var query = 'SELECT sponsorlevels.title FROM sponsorlevels JOIN sponsors ON sponsors.level = sponsorlevels.id WHERE sponsors.exhibition = ?';
			return $database.getItem(query, [this.id]);
		};

		return Exhibition;
	});
})();
