(function() {
  'use strict';

  angular.module('favorites').controller('FavoritesCtrl', ['$baseControllers', '$settings', '$scope', '$favorites', '$sessions', '$presentations', '$abstractpapers', '$persons', '$exhibitions', 'User', '$http', '$location', 'Features', '$cordovaToast', '$stateParams', '$filter', 'Notes',
  function($baseControllers, $settings, $scope, $favorites, $sessions, $presentations, $abstractpapers, $persons, $exhibitions, User, $http, $location, Features, $cordovaToast, $stateParams, $filter,Notes) {
    $baseControllers.applyListController($scope, $favorites);
    $scope.iPlannerEnabled = Features.iPlannerSync;
    $scope.showIplannerButton = User.iplanner ? false : false;
    $scope.sessions = [];
    $scope.presentations = [];
    $scope.persons = [];
    $scope.exhibitions = [];
    $scope.abstractpapers = [];
    $scope.notes = [];
    $scope.updating = false;
    var getFavorites = function() {

      $favorites.getElementsForModel($sessions, 1).then(function(elements) {
        $scope.sessions = $filter('orderBy')(elements, 'start_time');
      });

      $favorites.getElementsForModel($presentations, 2).then(function(elements) {
        $scope.presentations = elements;
      });

      $favorites.getElementsForModel($persons, 3).then(function(elements) {
        $scope.persons = elements;
      });

      $favorites.getElementsForModel($abstractpapers, 4).then(function(elements) {
        $scope.abstractpapers = elements;
      });

      $favorites.getElementsForModel($exhibitions, 10).then(function(elements) {
        $scope.exhibitions = elements;
      });
      $favorites.getNotes().then(function(elements) {

        elements.forEach(function(entry) {
          if (entry.reference_type === 1) {
            Notes.getLinkedObject(entry.reference_id ,'sessions', 'title AS title, code AS code').then(function(item) {
              entry.title = item.title;
              entry.type = 'Session';
            });

          } else if (entry.reference_type === 2) {
            Notes.getLinkedObject(entry.reference_id ,'presentations', 'title AS title').then(function(item) {
              entry.title = item.title;
              entry.type = 'Presentation';
            });
          } else if (entry.reference_type === 3) {
            Notes.getLinkedObject(entry.reference_id ,'persons', 'display_name AS title').then(function(item) {
              entry.title = item.title;
              entry.type = 'Person';
            });
          } else if (entry.reference_type === 4) {
            Notes.getLinkedObject(entry.reference_id ,'abstractpapers', 'title AS title').then(function(item) {
              entry.title = item.title;
              entry.type = 'Abstract';
            });
          } else if (entry.reference_type === 10) {
            Notes.getLinkedObject(entry.reference_id ,'exhibitions', 'name AS title').then(function(item) {
              entry.title = item.title;
              entry.type = 'Exhibitor';
            });
          }
        });
        $scope.notes = elements;
      });

    };
    
    $scope.exportNotes = function(){
      $scope.notes = $filter('orderBy')($scope.notes, 'reference_type');
      
      var output = '';
      $scope.notes.forEach(function(entry){
        var tmp = entry.type + ': ' + entry.title + ' ----- ' + entry.content + '%0D%0D';
        output += tmp;
      });
      
      window.open("mailto:"+'?subject=My Notes&body='+output);
      
    };

    getFavorites();
    $scope.syncAction = function() {
      if (User.iplanner) {
        syncIPlanner();
      } else {
        $location.path('/app/iplanner/login');
      }
    };

    var syncIPlanner = function() {
      if (User.iplanner) {
        $scope.updating = true;
        var url = $settings.iplannerSyncUrl;
        $http.post(url, {
          session : User.iplanner
        }).success(function(data) {
          data.forEach(function(favorite) {
            var fav = new $favorites(favorite);
            fav.save();
          });
          getFavorites();
          $cordovaToast.showShortBottom('imported');
          $scope.updating = false;
        }).error(function() {
          $scope.updating = false;
          $cordovaToast.showShortBottom('try again later');
        });
      }
    };

    if ($stateParams.sync) {
      syncIPlanner();
    }
  }]);
})();
