(function() {
	'use strict';

	angular.module('favorites').directive('dmsFavorite', ['$translate', '$cordovaToast',
	function($translate, $cordovaToast) {
		return {
			restrict : 'E',
			transclude : false,
			scope : {
				id : '@',
				type : '@',
			},
			controller : ['$scope', '$favorites',
			function($scope, $favorites) {

				$scope.getFavorites = function() {
					$scope.$watch('id', function() {
						if ($scope.id) {
							$favorites.getFavorite($scope.id, $scope.type).then(function(fav) {
								$scope.fav = angular.copy(fav);
							});
						}
					});

					$scope.$watch('fav', function() {
						if ($scope.fav) {
							if ($scope.fav.deleted_at === null) {
								$scope.isFavorite = true;
							} else {
								$scope.isFavorite = false;
							}
						}
					});
				};
				$scope.getFavorites();
				/**
				 * @ngdoc function
				 * @name kongressapp.dms-favorite.addFavorite
				 * @description Fügt einen Favoriten hinzu.
				 */
				$scope.toggleFavorite = function() {

					var favorite = {};
					var message = '';
					var del = '';
					var add = '';
					var id = $scope.id;
					var type = $scope.type;
					$translate('FAVORITE_ADD').then(function(item) {
						add = item;
					});
					$translate('FAVORITE_DEL').then(function(item) {
						del = item;
					});

					$favorites.getFavorite(id, type).then(function(res) {
						favorite = res;
						if (favorite) {
							if (favorite.deleted_at !== null) {
								$favorites.updateFavorite(id, type, null);
								message = add;
							} else {
								$favorites.updateFavorite(id, type, new Date().toISOString());
								message = del;
							}
						} else {
							$favorites.addFavorite(id, type);
							message = add;
						}

						$cordovaToast.showShortBottom(message);
					});
					$scope.isFavorite = !$scope.isFavorite;
				};

			}],
			templateUrl : 'modules/favorites/directives/favoriteButton/button.html'
		};
	}]);
})();
