'use strict';
angular.module('href.directives', []).directive('a', function() {
	return {
		restrict : 'E',
		compile : function() {
			return function(scope, element) {
				element.on('click', function(event) {
					if (element.attr('href')) {
						var link = element.attr('href');
						if (link.indexOf('http://') > -1 || link.indexOf('https://') > -1) {
							event.preventDefault();
							window.open(link, '_system', 'location=yes');
						}
					}
				});
			};
		}
	};
}).directive('compile', function($compile, Medias) {
	return function(scope, element, attrs) {
		var ready;
		scope.$watch(function(scope) {
			return scope.$eval(attrs.compile);
		}, function(value) {
			if (value) {
				value.split('"').forEach(function(item) {
					if (item.indexOf('http://') > -1 || item.indexOf('https://') > -1) {
						var filePath = item.split('/');
						Medias.getItemByName(filePath[filePath.length - 1]).then(function(media) {
							item = media.media_file || item;
						});
						item += '" style="max-width:100%;';
					}

          ready = ready ? ready + '"' + item : item;

				});
				element.html(ready);
				$compile(element.contents())(scope);
			}
		});
	};
});

