'use strict';
angular.module('launchapp', ['ionic', 'ngCordova']).service('AppLauncher', function($settings, $cordovaDialogs) {

	this.checkExist = function() {
		var application;
		if (ionic.Platform.isAndroid()) {
			application = $settings.androidExternal;
		} else if (ionic.Platform.isIOS()) {
			application = $settings.iosExternal;
		}
		navigator.startApp.check(application, function(message) {/* success */
			console.log(message);
			// => OK
		}, function(error) {/* error */
			console.log(error);
		});
	};

	var promptDownload = function(url) {
		$cordovaDialogs.confirm('App not installed.', 'Info', ['OK', 'Later']).then(function(buttonIndex) {
			// no button = 0, 'OK' = 1, 'Cancel' = 2
			var btnIndex = buttonIndex;
			if (btnIndex == 1) {
				window.open(url, '_system');
			}
		});
	};

	this.startApp = function(param, id) {
		if (ionic.Platform.isAndroid()) {
			var application = $settings.androidExternal;
			var object = {};
			object[param] = id;
			//check if exists
			navigator.startApp.check(application, function() {/* success */
				console.log(application + ' exists');
				navigator.startApp.start([application, [object]], function() {/* success */
					console.log(application + ' started with params ' + JSON.stringify(object));
					// => OK app was started with params
				}, function(error) {/* error */
					console.log(error);

				});
			}, function(error) {/* error TODO: download app from store*/
				console.log(error);
				promptDownload($settings.androidExternalStoreLink);

			});

		} else if (ionic.Platform.isIOS()) {
			//check if exist
			navigator.startApp.check($settings.iosExternal, function() {/* success */
				console.log($settings.iosExternal + ' exists');
				var path = $settings.iosExternal + '?' + param + '=' + id;
				navigator.startApp.start(path, function() {/* success */
					console.log($settings.iosExternal + ' started with link ' + path);
					// => OK start app with params
				}, function(error) {/* error */
					console.log(error);
				});
			}, function(error) {/* error TODO: download app from store */
				console.log(error);
				promptDownload($settings.iosExternalStoreLink);
			});

		}
	};
});
