(function() {
  'use strict';
  angular.module('liveVote').directive('dmsLiveVote', function() {
    return {
      restrict : 'E',
      scope : {
        target : '='
      },
      templateUrl : 'modules/liveVote/directive/template.html',
      controller : function($scope, $http, $settings, Socket, $translate, User) {
        var refreshQuestion = function() {
          $http.get($settings.liveVote + '/livevotings?filter[where][and][1][target]=' + $scope.target + '&filter[where][and][0][isActive]=true').success(function(questions) {
            $scope.question = questions[0];
            $scope.transferStatus = false;
          });
        };

        refreshQuestion();
        var channel = 'livevoting:' + $settings.conferenceId + ':' + $scope.target;
        Socket.join(channel);
        Socket.on('livevoting', function() {
          refreshQuestion();
        });

        $scope.$on('$destroy', function() {
          Socket.leave(channel);
        });

        $scope.send = function(number) {
          var answer = {
            text : '' + number,
            conference : '' + $settings.conferenceId,
            target : $scope.target,
            question : '' + $scope.question.id,
            user : User.id,
          };
          $http.post($settings.liveVote + '/votes', answer).success(function() {
            $scope.question = {};
            $translate('VOTETHX').then(function(item) {
              $scope.question.question = item;
              $scope.transferStatus = 'success';
            });
          }).error(function() {
            $scope.question = {};
            $translate('VOTEERR').then(function(item) {
              $scope.question.question = item;
              $scope.transferStatus = 'error';
            });
          });
        };
      }
    };
  });
})();
