'use strict';

angular.module('login').controller('LoginCtrl', function($scope, $http, $settings, $window, User, $timeout, $stateParams, $location, $pubsub, $translate) {
	$scope.user = {};
	var source = $stateParams.source;

	$scope.colorHint = 'positive';
	$scope.message = 'Login';
	$scope.loginFailed = '';

	$translate('LOGIN_ERROR').then(function(item) {
		$scope.loginFailed = item;
	});
	$scope.login = function() {
		$http.post($settings.apiHost + '/auth/token/', $scope.user).success(function(data) {
			User.public = data.id;
			User.secret = data.secret;
			User.name = $scope.user.username;
			User.save();
			// $scope.erfolg();
			var path = '/app/' + source;
			$location.path(path, {});
			$pubsub.publish('logged_in', {});

		}).error(function() {
			$scope.fehler();
		});
	};

	$scope.logout = function() {
		User.public = '';
		User.secret = '';
		User.name = '';
    User.chat = User.chat || true;
		User.save();
	};

	$scope.loggedIn = function() {
		if (User.secret) {
			$scope.user.username = User.name;
			return true;
		}
		return false;
	};

	$scope.fehler = function() {

		$scope.colorHint = 'assertive';
		$scope.message = $scope.loginFailed;
		$timeout(function() {
			$scope.colorHint = 'positive';
			$scope.message = 'Login';

		}, 3000);

	};
});
