(function(){
  'use strict';

  angular.module('login')
  .controller('iplannerCtrl', ['$scope', 'User', '$http', '$location', '$translate', '$timeout', '$settings', function($scope, User, $http, $location, $translate, $timeout, $settings) {
    $scope.title = 'iplanner';
    $scope.user = {};
    var loginFailed;

    $translate('LOGIN_ERROR').then(function(item) {
      loginFailed = item;
    });

    $scope.loggedIn = function() {
      return User.iplanner;
    };

    $scope.colorHint = 'positive';
    $scope.message = 'login';
    $translate('LOGIN_USER_HINT').then(function(item){
      $scope.usernameHint = item;
    });
    $translate('LOGIN_PASS_HINT').then(function(item){
      $scope.passwordHint = item;
    });
    $translate('SIGN_UP').then(function(item){
      $scope.registerMessage = item;
    });
    $scope.registerUrl = 'https://www.abstractserver.com/Login/' + $settings.name + '/';

    $scope.login = function() {
      $http.post('https://www.abstractserver.com/Login/' + $settings.name + '/api/', $scope.user)
      .success(function(response) {
        User.iplanner = response.session;
        User.save();
        $location.path('/app/favoritessync');
      })
      .error(function() {
        $scope.message = loginFailed;
        $scope.colorHint = 'assertive';
        $timeout(function() {
          $scope.colorHint = 'positive';
          $scope.message = 'Login';
        }, 3000);

      });
    };
  }]);
})();
