(function() {
  'use strict';
  var mailbox = {},
    subscribers = {};

  angular.module('mailbox', [])
    .factory('mailbox', function($q) {
      var write = function(target, obj) {
        mailbox[target] = mailbox[target] || [];
        mailbox[target].push(obj);
        notify(target);
      };

      var next = function(target) {
        return mailbox[target].splice(0, 1)[0];
      };

      var hasNext = function(target) {
        return mailbox[target] ? mailbox[target].length > 0 : false;
      };


      var notify = function(target) {
        if (subscribers[target]) {
          subscribers[target].resolve();
        }
      };

      var subscribe = function(target) {
        var promise = $q.defer();
        subscribers[target] = promise;
        return promise.promise;
      };

      return {
        write: write,
        next: next,
        hasNext: hasNext,
        subscribe: subscribe
      };
    });
})();
