'use strict';

angular.module('maps.model', []).factory('$maps', function($common, $database) {
	var Map = $common.model();
	Map.tableName = 'maps';
	Map.fields = {
		'id' : 'text primary key',
		'title' : 'text',
		'description' : 'text',
		'order' : 'integer',
		'map_file' : 'text',
		'map_file_thumbnail' : 'text',
		'width' : 'integer',
		'height' : 'integer'
	};

	Map.getMarkers = function(id) {
		var query = 'SELECT coordinate_x as lat,coordinate_y as lng, locations.name as name, message as orimessage,exhibitions.name AS exhibition, location FROM locationlinks Left Join locations on locationlinks.location = locations.id  Left Join exhibitions on exhibitions.locations like locations.id WHERE assigned_map = ?';
		return $database.getItems(query, [id]);
	};

	Map.getMarker = function(id) {
		var query = 'SELECT coordinate_x as lat,coordinate_y as lng FROM locationlinks WHERE id = ?';
		return $database.getItem(query, [id]);
	};

	return Map;
});
