(function() {
  'use strict';
  angular.module('medias').factory('Medias', function($common, $database) {
    var Media = $common.model();
    Media.tableName = 'medias';
    Media.fields = {
      'id' : 'text primary key',
      'description' : 'text',
      'mime_type' : 'text',
      'media_file' : 'text',
    };
    Media.get = function(id) {
      var query = 'Select * FROM medias WHERE id = ?';
      return $database.getItem(query, [id]);
    };

    Media.getItemByName = function(name) {
      var query = 'Select media_file FROM medias WHERE media_file like ?';
      return $database.getItem(query, ['%' + name]);
    };
    return Media;
  });
})();
