(function() {
	'use strict';

	angular.module('menu').controller('MenuCtrl', function($scope, $translate, $menu, $document, $ionicNavBarDelegate, $pubsub, $ionicSideMenuDelegate, $ionicHistory) {

		$scope.lang = $translate.use();

		var getAll = function() {
			$menu.all().then(function(items) {
				items.forEach(function(entry) {
					entry.getIconFile().then(function(icon) {
						if (icon) {
							entry.iconfile = icon.media_file;
						}
					});
				});
				$scope.elements = items;
			});
		};

		$scope.elements = [];
		getAll();

		$pubsub.subscribe('fileSynced:medias', getAll);

		$scope.backButtonClicked = function() {
			var header = $document[0].body.querySelector('.bar-header');
			header.style[ionic.CSS.TRANSFORM] = 'translate3d(0,  0, 0)';
			for (var i = 0,
			    j = header.children.length; i < j; i++) {
				header.children[i].style.opacity = 1;
			}
			if ($ionicHistory.backView()) {
				$ionicHistory.goBack();
			} else {
				$ionicSideMenuDelegate.toggleLeft(true);
			}
		};

		$scope.backButtonStyle = function() {
			if ($ionicHistory.backView()) {
				return 'ion-ios-arrow-back';
			} else {
				return 'ion-navicon';
			}

		};

	});
})();
