(function() {
  'use strict';

  angular.module('menu')
    .directive('hideWhen', ['$window', function($window) {
      return {
        restrict: 'A',
        link: function($scope, $element, $attr) {

          function checkExpose() {
            var mq = $attr.hideWhen === 'large' ? '(min-width:768px)' : $attr.hideWhen;
            if ($window.matchMedia(mq).matches) {
              $element.addClass('ng-hide');
            } else {
              $element.removeClass('ng-hide');
            }
          }

          function onResize() {
            debouncedCheck();
          }

          var debouncedCheck = ionic.debounce(function() {
            $scope.$apply(function() {
              checkExpose();
            });
          }, 300, false);

          checkExpose();

          ionic.on('resize', onResize, $window);

          $scope.$on('$destroy', function() {
            ionic.off('resize', onResize, $window);
          });

        }
      };
    }]);
})();
