(function() {
	'use strict';

	angular.module('menu').directive('dmsEventcountbubble', function($cordovaPush) {
		return {
			restrict : 'E',
			scope : {
				eventKey : '=event'
			},
			templateUrl : 'modules/menu/directives/menubadge/badge.html',
			controller : ['$scope', '$pubsub', '$posts',
			function($scope, $pubsub, $posts) {
				if ($scope.eventKey === '#/app/posts') {
					var bubbleUpdate = function() {
						$posts.unreadPosts().then(function(count) {
							$scope.count = count.count;
							$cordovaPush.setBadgeNumber(count.count);
						});
					};
					bubbleUpdate();
					$pubsub.subscribe('posts', bubbleUpdate);

					var refreshTimeout = function() {
						$timeout(function() {
							bubbleUpdate();
							refreshTimeout();
						}, 60000);
					};
				}
			}]

		};
	});
})();
