'use strict';

angular.module('post.model', []).factory('$posts', function($common, $database) {
	var Post = $common.model();
	Post.tableName = 'posts';
	Post.fields = {
		'id' : 'text primary key',
		'entity_id' : 'integer',
		'source' : 'integer',
		'title_image' : 'text',
		'content' : 'text',
		'title' : 'text',
		'created_at' : 'text',
		'modified_at' : 'text',
		'deleted_at' : 'text',
		'publish_at' : 'text',
		'is_watched' : 'integer',
	};

	Post.all = function() {
		var query = 'SELECT * FROM posts WHERE datetime(publish_at) < datetime(\'now\',\'localtime\')';
		return $database.getItems(query, [], Post);
	};

	Post.unreadPosts = function() {
		var query = 'SELECT COUNT(id) AS count FROM posts WHERE datetime(publish_at) <= datetime(\'now\', \'localtime\') AND ifnull(is_watched,0) != 1';
		return $database.getItem(query);
	};
	
	Post.watching = function() {
        var query = 'Update posts SET is_watched = 1 WHERE datetime(publish_at) <= datetime(\'now\', \'localtime\')';
        return $database.execute(query);
      };
	
	return Post;
});

 