'use strict';

angular.module('feedback.controller', []).controller('PollCtrl', function($scope, $stateParams, Polls, Questions, Votes) {

  var id = $stateParams.id;
  var ref_id = $stateParams.ref_id;
  var ref_type = $stateParams.ref_type;

  var next = [];

  $scope.question = {};

  Polls.get($stateParams.id).then(function(poll) {
    $scope.title = poll.title;
    poll = poll;
    setQuestion(poll.question);
    nextVote();
  });

  $scope.save = function(question, answer, nextvote) {

    var active_question = {
      'poll': id,
      'reference_id': ref_id,
      'reference_type': ref_type,
      'question': question,
      'answer': {'answer':answer},
      'voted_at': new Date().getTime()
    };
    Votes.saveVote(active_question);

    if (nextvote) {
      setQuestion(nextvote);
    }
    if (question.length > 0) {
      if (next.length) {
        nextVote();
      } else {
        lastVote();
      }
    }
  };

  var nextVote = function() {
    Questions.get(next.pop()).then(function(item) {
      $scope.question = item;
      $scope.choices = JSON.parse(item.choices);
      if (item.next) {
        setQuestion(item.next);
      }
    });
  };

  var lastVote = function() {
    $scope.save('', '');
    $scope.question = {
      type: 4
    };
  };

  var setQuestion = function(question) {
    next.push(question);
  };

});
