'use strict';

angular.module('feedback.directives', []).directive('dmsQuestion', function() {
	return {
		restrict : 'E',
		transclude : true,
		scope : {
			question : '=',
			choices : '=',
			saveit : '&save'
		},
		controller : function($scope) {
			$scope.$watch('choice', function() {
				$scope.choices.forEach(function(choice) {
					if (choice.text === $scope.choice) {
						$scope.next = choice.next;
					}
				});
			});

			$scope.$watch('choices', function() {
				$scope.choice = '';
				$scope.next = '';
			});

		},
		templateUrl : 'modules/polls/views/question.html'
	};
}).directive('singlechoice', function() {
	return {
		restrict : 'E',
		replace : true,
		scope : {
			data : '='
		},
		templateUrl : 'modules/polls/views/single_choice.html'
	};
}).directive('multiplechoice', function() {
	return {
		restrict : 'E',
		replace : true,
		scope : {
			data : '='
		},
		templateUrl : 'modules/polls/views/multiple_choice.html'
	};
}).directive('freeform', function() {
	return {
		restrict : 'E',
		replace : true,
		scope : {
			data : '='
		},
		templateUrl : 'modules/polls/views/free_form.html'
	};
}).directive('starrange', function() {
	return {
		restrict : 'E',
		replace : true,
		scope : {
			data : '='
		},
		templateUrl : 'modules/polls/views/star_rating.html'
	};
});

