'use strict';

angular.module('feedback.model', []).factory('Questions', function ($common) {
    var Question = $common.model();
    Question.tableName = 'questions';
    Question.fields = {
        'id': 'text primary key',
        'next': 'text',
        'text': 'text',
        'type': 'integer',
        'choices': 'text'
    };

    return Question;
}).factory('Polls', function ($common) {
    var Poll = $common.model();
    Poll.tableName = 'polls';
    Poll.fields = {
        'id': 'text primary key',
        'title': 'text',
        'question': 'text'
    };

    return Poll;
}).factory('Votes', function ($common, $database) {
    var Vote = $common.model();
    Vote.tableName = 'votes';
    Vote.fields = {
        'pk': 'integer primary key autoincrement',
        'poll': 'text',
        'reference_id': 'text',
        'reference_type': 'integer',
        'question': 'text',
        'answer': 'text',
        'voted_at': 'date',
        'uploaded_at': 'date'
    };
    Vote.saveVote = function (active_item) {
        var query = 'INSERT INTO votes (poll,reference_id,reference_type,question,answer,voted_at) VALUES (?,?,?,?,?,?)';
        return $database.execute(query, [active_item.poll, active_item.reference_id, active_item.reference_type, active_item.question, JSON.stringify(active_item.answer), active_item.voted_at]);
    };
    Vote.findVote = function (poll) {
        var query = 'SELECT * FROM votes WHERE poll = ?';
        return $database.execute(query, [poll]);
    };
    return Vote;
});
