'use strict';

angular.module('presentation.controller', []).controller('PresentationListCtrl', function($scope, $presentations, $baseControllers, $sce, $common) {

  $baseControllers.applyListController($scope, $presentations);

  $scope.cutPresentation = $common.view.cut(44, '<h4>', '</h4>');

  $scope.isCutted = function(presentation) {

    if (presentation.length > 44) {
      return {
        'margin-top' : '-16px'
      };
    } else {
      return {
        'margin-top' : '0px'
      };
    }

  };

}).controller('PresentationDetailCtrl', function($scope, $stateParams, $presentations, $settings, Features, AppLauncher) {
  $scope.isNative = $settings.isNative;
  $scope.shareEnabled = Features.shareFunction;
  $scope.platform = $settings.platform;
  var id = $stateParams.id;
  $scope.linkId = $stateParams.linkId;
  console.log($scope.linkId + ' ' + id);
  $scope.headTitle = 'Presentations';
  if ($scope.linkId) {
    $scope.cuttedId = parseInt($scope.linkId.substr($scope.linkId.length - 10));
  }
  $presentations.get(id).then(function(presentation) {
    presentation.getAbstracts().then(function(abstracts) {
      presentation.abstractpaper = abstracts[0];
    });
    presentation.getSessions().then(function(sessions) {
      $scope.sessions = sessions;
    });

    presentation.getCode().then(function(code) {
      presentation.code = code.code;
    });

    presentation.getChair().then(function(persons) {
      $scope.persons = persons;
    });
    $scope.item = presentation;
  });

  $scope.orderMaterial = function() {
    AppLauncher.startApp('presentationId', $scope.cuttedId);
  };

  $scope.share = function() {
    window.plugins.socialsharing.share('I am visiting ' + $scope.item.title);
  };
});
