'use strict';

angular.module('presentation.directives', []).directive('presentationlist', function($sce, Pagination, $ionicScrollDelegate) {
	return {
		restrict : 'E',
		transclude : true,
		scope : {
			data : '=',
			hideTime : '=',
			paginated : '='
		},
		link : function(scope) {
			scope.$watch('data', function() {
				scope.elements = scope.data;
				scope.limit = 50;
				if (scope.paginated) {
					scope.pagination = Pagination.getNew(scope.limit);
					scope.start = scope.pagination.page * scope.limit;

					scope.pagination.numPages = Math.ceil(scope.elements.length / scope.limit);
				} else {
					scope.start = 0;
					scope.limit = scope.elements.length;
				}

			});
			scope.previous = function() {
				scope.pagination.prevPage();
				scope.start = scope.pagination.page * scope.limit;
				$ionicScrollDelegate.scrollTop();
			};
			scope.next = function() {
				scope.pagination.nextPage();
				scope.start = scope.pagination.page * scope.limit;
				$ionicScrollDelegate.scrollTop();
			};

			scope.cutPresentation = function(session) {

				var first = session.substr(0, 44);
				if (first !== session) {
					var lastspace = first.lastIndexOf(' ');

					if (lastspace !== -1) {
						first = first.substr(0, lastspace);
						lastspace = first.length;
						first += '</h4><h4>';
						first += session.substr(lastspace);
					} else {
						first += '</h4><h4>';
						first += session.substr(44);
					}

				}
				return $sce.trustAsHtml(first);

			};

			scope.isCutted = function(session) {

				if (session.length > 44) {
					return {
						'margin-top' : '-16px'
					};
				} else {
					return {
						'margin-top' : '0px'
					};
				}

			};

		},
		templateUrl : 'modules/presentation/presentation-directive.html'
	};
});
