(function() {
  'use strict';
  angular.module('questionAndAnswer').directive('dmsQuestionAndAnswer', function() {
    return {
      restrict : 'E',
      scope : {
        target : '='
      },
      templateUrl : 'modules/questionAndAnswer/directive/template.html',
      controller : function($scope, $http, $settings, Socket, $timeout, User) {
        var channel = 'questionandanswer:' + $settings.conferenceId + ':' + $scope.target;
        $scope.isActive = false;
        $scope.submit = 'false';
        $scope.buttonwidth = '60px';
        $http.get($settings.liveVote + '/events?filter[where][and][1][target]=' + $scope.target + '&filter[where][and][0][isQandAActive]=true').success(function(data) {
          $scope.isActive = data[0].isQandAActive;
        });

        Socket.join(channel);
        Socket.on('questionandanswer', function() {
          $http.get($settings.liveVote + '/events?filter[where][target]=' + $scope.target).success(function(data) {
            $scope.isActive = data[0].isQandAActive;
          });
        });

        $scope.$on('$destroy', function() {
          Socket.leave(channel);
        });

        $scope.send = function() {
          var question = {
            text : $scope.question,
            conference : $settings.conferenceId,
            target : $scope.target,
            user : User.id,
          };

          $scope.buttonwidth = '100%';
          $scope.submit = 'progress';

          $timeout(function() {
            $http.post($settings.liveVote + '/questions', question).success(function() {
              transferSuccess('true');
            }).error(function() {
              transferSuccess('error');
            });
          }, 1000);
        };

        var transferSuccess = function(status) {
          $scope.submit = status;
          if (status === 'true') {
            $scope.question = '';
          }
          $timeout(function() {
            $scope.submit = 'false';
            $scope.buttonwidth = '60px';
          }, 1000);
        };
      }
    };
  });
})();
