'use strict';

angular.module('quiz').controller('QuizCtrl', function($scope, $stateParams, Polls, Questions, Votes, $window, $ionicScrollDelegate) {

	var id = $stateParams.id;

	var next = [];
	var answers = JSON.parse($window.localStorage.getItem(id)) || [];

	$scope.active = -1;
	$scope.question = {};
	$scope.abort = false;
	$scope.person = {};
	$scope.agb = false;

	Votes.findVote(id).then(function(vote) {
		if (vote.rows.length > 0) {
			$scope.question = {
				type : 5
			};
		} else {
			Polls.get($stateParams.id).then(function(poll) {
				$scope.title = poll.title;
				poll = poll;
				setQuestion(poll.question);
				nextVote();
			});
		}
	});

	$scope.questionBefore = function() {
		$scope.active--;
		Questions.get(next[$scope.active]).then(function(item) {
			$scope.question = item;
			$scope.choices = JSON.parse(item.choices);
			$scope.choice = answers[$scope.active] || '';
		});
		$ionicScrollDelegate.scrollTop();
	};

	$scope.save = function(question, answer, nextvote) {

		answers[$scope.active] = answer;
		$window.localStorage.setItem(id, JSON.stringify(answers));
		if (nextvote) {
			setQuestion(nextvote);
		}
		if (next.length > $scope.active + 1) {
			nextVote();
		} else {
			lastVote();
		}
		$ionicScrollDelegate.scrollTop();
	};

	var nextVote = function() {
		$scope.active++;
		Questions.get(next[$scope.active]).then(function(item) {
			$scope.question = item;
			$scope.choices = JSON.parse(item.choices);
			$scope.choice = answers[$scope.active] || '';

			if (item.next && $scope.active === next.length-1) {
				setQuestion(item.next);
			}
		});
	};

	var lastVote = function() {
		$scope.question.type = 4;
	};

	$scope.quit = function() {
		$scope.question = {
			type : 4
		};
		$scope.abort = true;
	};

	$scope.submit = function(lastQuestionId) {
		var active_question = {
			'poll' : id,
			'question' : lastQuestionId,
			'answer' : {
				'person' : $scope.person,
				'answers' : answers
			},
			'voted_at' : new Date().getTime(),
			'reference_type' : 0,
			'reference_id' : 'quiz'
		};
		Votes.saveVote(active_question);
		$scope.question = {
			type : 5
		};
	};

	var setQuestion = function(question) {
		next.push(question);
	};

});
