'use strict';

angular.module('search.controller', []).controller('SearchCtrl', function($search, $scope, $translate,$ionicScrollDelegate) {

  $translate('SEARCH').then(function(item) {
    $scope.placeholder = item;
  });
  $scope.searchString = '';
  $scope.searchString = $search.getSearch();

  $scope.search = function(searchstring) {

     $search.setSearch(searchstring);
    if (searchstring.length > 2) {

      $search.getSessions(searchstring).then(function(sessions) {
        $scope.sessions = sessions;
      });
      $search.getPresentations(searchstring).then(function(presentations) {
        $scope.presentations = presentations;
      });
      $search.getPersons(searchstring).then(function(persons) {
        $scope.persons = persons;
      });
      $search.getAbstracts(searchstring).then(function(abstracts) {
        $scope.abstracts = abstracts;
      });

      $search.getExhibitions(searchstring).then(function(exhibitions) {
        $scope.exhibitions = exhibitions;
      });
    } else {
      $scope.sessions = '';
      $scope.presentations = '';
      $scope.persons = '';
      $scope.abstracts = '';
      $scope.exhibitions = '';
    }
    $ionicScrollDelegate.scrollTop();
  };

  
  $scope.$watch('searchString', function(newValue, oldValue) {
    if (newValue.length < 2) {
      $scope.search('');
    } else {
      $scope.search($scope.searchString);
    }
  });

});
