'use strict';

angular.module('search.factory', []).factory('$search', function($database, $exhibitions, $presentations) {

	var searchString = '';
	return {

		setSearch : function(searchValue) {
			searchString = searchValue;
			return true;
		},
		getSearch : function() {
		  console.log('searchstring is: ' + searchString);
			return searchString;
		},
		getSessions : function(searchString) {
			// TODO: prepared statement doesn't work like expected with the "LIKE %?%" statement.
			var query = 'SELECT sessions.id, sessions.code, sessions.image, sessions.color,sessions.font_color, sessions.start_time, sessions.end_time, sessions.title, sessiontypes.name AS session_type FROM sessions JOIN sessiontypes ON sessiontypes.id = sessions.session_type WHERE title LIKE "%' + searchString + '%" OR code LIKE "%' + searchString + '%"';
			return $database.getItems(query, []);
		},
		getPersons : function(searchString) {
			// TODO: prepared statement doesn't work like expected with the "LIKE %?%" statement.
			var query = 'SELECT * FROM persons WHERE first_name LIKE "%' + searchString + '%" OR last_name LIKE "%' + searchString + '%" OR middle_name LIKE "%' + searchString + '%" ORDER BY last_name';
			return $database.getItems(query, []);
		},
		getPresentations : function(searchString) {
			// TODO: prepared statement doesn't work like expected with the "LIKE %?%" statement.
			var query = 'SELECT schedualassignments.code, sessiontypes.name AS session_type, schedualassignments.start_time, schedualassignments.end_time, presentations.id, sessions.color, presentations.abstracts, presentations.title, presentations.outline, presentations.external_link, persons.last_name, persons.first_name,persons.city, persons.country  FROM schedualassignments JOIN presentations ON schedualassignments.presentation = presentations.id LEFT JOIN roles ON roles.chair = presentations.id LEFT JOIN persons ON persons.id = roles.person JOIN sessions on schedualassignments.session = sessions.id  JOIN sessiontypes ON sessiontypes.id = sessions.session_type WHERE presentations.title LIKE "%' + searchString + '%" OR schedualassignments.code LIKE "%' + searchString + '%" ORDER BY schedualassignments.start_time, roles.\'order\'';
			return $database.getItems(query, [], $presentations).then(function(presentations) {
				presentations = presentations.reduce(function(newPresentations, presentation) {
					var speaker = {
						first_name : presentation.first_name,
						last_name : presentation.last_name,
						country : presentation.country,
						city : presentation.city,
						order : presentation.roleOrder,
					};
					if (!newPresentations[presentation.id]) {
						newPresentations[presentation.id] = presentation;
						newPresentations[presentation.id].speakers = [];
					}
					newPresentations[presentation.id].speakers.push(speaker);
					return newPresentations;
				}, {});

				return Object.keys(presentations).map(function(k) {
					return presentations[k];
				});
			});
		},
		getAbstracts : function(searchString) {
			// TODO: prepared statement doesn't work like expected with the "LIKE %?%" statement.
			var query = 'SELECT abstractpapers.id, abstractpapers.title, schedualassignments.code, roles.function, group_concat(persons.last_name) AS speaker FROM abstractpapers JOIN presentations ON presentations.abstracts = abstractpapers.id JOIN schedualassignments ON schedualassignments.presentation = presentations.id JOIN roles ON roles.chair = presentations.id JOIN persons ON persons.id = roles.person WHERE schedualassignments.code IS NOT NULL AND (abstractpapers.title LIKE "%' + searchString + '%" OR abstractpapers.text LIKE "%' + searchString + '%") AND (abstractpapers.embargo IS NULL OR abstractpapers.embargo < date(\'now\')) GROUP BY abstractpapers.id ORDER BY roles.\'order\' ';
			return $database.getItems(query, []);
		},
		getExhibitions : function(searchString) {
			// TODO: prepared statement doesn't work like expected with the "LIKE %?%" statement.
			var query = 'Select * FROM exhibitions WHERE name LIKE "%' + searchString + '%" OR description LIKE "%' + searchString + '%"';
			return $database.getItems(query, [], $exhibitions);
		},
	};

});
