(function() {
  'use strict';

  angular.module('sessions').controller('SessionCtrl', function($scope, $settings, $stateParams, $sessions, Features, $q) {
    $scope.shareEnabled = Features.shareFunction;
    var id = $scope.id = $stateParams.id;
    var _presentations;
    var _tags;
    var _persons;
    var _locations;
    var _poll;
    var promises = [];
    $scope.platform = $settings.platform;
    $scope.isNative = $settings.isNative;

    $sessions.get(id).then(function(session) {
      $scope.item = session;

      promises.push(session.getPresentations().then(function(presentations) {
        _presentations = presentations;
      }));

      if (session.tags) {
        promises.push(session.getTags().then(function(tags) {
          _tags = tags;
        }));
      }

      promises.push(session.getChair().then(function(persons) {
        _persons = persons;
      }));

      if (session.locations) {
        promises.push(session.getLocations().then(function(locations) {

          session.location = locations[0];
          _locations = locations;
        }));
      }

      if (session.poll) {
        promises.push(session.getPoll(session.poll).then(function(poll) {
          _poll = poll;
        }));
      }

      $q.all(promises).then(function() {
        $scope.presentations = _presentations;
        $scope.persons = _persons;
        $scope.locations = _locations;
        $scope.poll = _poll;
        $scope.loaded = true;
      });
    });

    $scope.share = function() {
      window.plugins.socialsharing.share('I am visiting ' + $scope.item.title);
    };

  });
})();
