(function() {
  'use strict';

  angular.module('sessions')
  .directive('sessionlisthourseperated', ['$filter', '$common', '$translate', function($filter, $common, $translate) {
    return {
      restrict: 'E',
      transclude: true,
      scope: {
        data: '=',
      },
      link: function(scope) {
        scope.elements = [];
        scope.cutSession = $common.view.cut(44, '<h4>', '</h4>');
        scope.isCutted = function(session) {
          if (session.length > 44) {
            return {
              'margin-top': '-16px'
            };
          } else {
            return {
              'margin-top': '0px'
            };
          }
        };
        var uhr;
        var format;
        $translate('UHR').then(function(item) {
          uhr = item;
        });
        $translate('DATE_FORMAT').then(function(item) {
          format = item;
        });

        scope.$watch('data', function() {
          if (scope.data) {
            scope.elements= [];
            var date = 0;
            var day = 0;
            var dateBefore = 2359;
            var dayBefore = 0;

            scope.data.forEach(function(entry) {
              day = $filter('date')(entry.start_time, 'dd');
              if (day > dayBefore || (day < 5 && dayBefore > 20)) {
                dayBefore = day;
                date = 0;
                scope.elements.push({
                  title: $filter('date')(entry.start_time, format) + uhr,
                  isHead: true
                });
              }

              date = $filter('date')(entry.start_time, 'HHmm');
              if (date > dateBefore || (date < 1000 && dateBefore > 1000)) {
                if (date > dateBefore) {
                  var time = $filter('date')(entry.start_time, 'HH:mm ') + uhr;
                  scope.elements.push({
                    title: time,
                    isHead: true
                  });
                }
                dateBefore = date;

              }

              scope.elements.push(entry);
            });
          }
        });

      },
      templateUrl: 'modules/session/directives/sessionlisthourseperated/list.html'
    };
  }]);
})();
