(function() {
  'use strict';

  angular.module('sessions').config(['$stateProvider', function($stateProvider) {
    $stateProvider.state('app.sessions', {
      url: '/sessions',
      views: {
        'menuContent': {
          templateUrl: 'modules/session/views/list.html',
          controller: 'SessionsCtrl'
        }
      }
    }).state('app.sessionsByDate', {
      url: '/sessions/date/:date',
      views: {
        'menuContent': {
          templateUrl: 'modules/session/views/list.html',
          controller: 'SessionsDateCtrl'
        }
      }
    }).state('app.sessionsNow', {
      cache: false,
      url: '/sessions/now',
      views: {
        'menuContent': {
          templateUrl: 'modules/session/views/now.html',
          controller: 'NowCtrl'
        }
      }
    }).state('app.sessionGrid', {
      url: '/sessions/grid/:date',
      views: {
        'menuContent': {
          templateUrl: 'modules/session/views/grid.html',
          controller: 'SessionGridCtrl'
        }
      }
    }).state('app.sessionTypes', {
      url: '/sessiontypes',
      views: {
        'menuContent': {
          templateUrl: 'modules/session/views/sessiontypes.html',
          controller: 'SessionTypesCtrl'
        }
      }
    }).state('app.sessionType', {
      url: '/sessiontypes/:id',
      views: {
        'menuContent': {
          templateUrl: 'modules/session/views/type.list.html',
          controller: 'SessionTypeCtrl'
        }
      }
    }).state('app.single', {
      url: '/sessions/:id',
      views: {
        'menuContent': {
          templateUrl: 'modules/session/views/detail.html',
          controller: 'SessionCtrl'
        }
      }
    }).state('app.sessionTypeGroups', {
      url: '/sessiontypegroups',
      views: {
        'menuContent': {
          templateUrl: 'modules/session/views/sessiontypegroups.html',
          controller: 'SessionTypeGroupsCtrl'
        }
      }
    }).state('app.sessionTypeGroup', {
      url: '/sessiontypegroups/:id',
      views: {
        'menuContent': {
          templateUrl: 'modules/session/views/typegroup.list.html',
          controller: 'SessionTypeGroupCtrl'
        }
      }
    });
  }]);
})();
