'use strict';

angular.module('sponsor.controller', []).controller('SponsorListCtrl', function($scope, Sponsors, Sponsorlevels, $filter) {
	$scope.sponsors = [];
	$scope.levels = [];
	$scope.isAndroid = ionic.Platform.isAndroid();

	$scope.getItemHeight = function(item) {
		return (140 + parseInt(item.name.length / 35) * 14);
	};

	Sponsorlevels.all().then(function(levels) {
		$scope.levels = $filter('orderBy')(levels, 'level');
		$scope.levels.forEach(function(level) {
			level.getSponsors().then(function(sponsors) {
				sponsors.forEach(function(entry) {
					entry.getExhibition().then(function(exhibition) {
						exhibition.getLocations().then(function(locations) {
							entry.location = '';
							locations.forEach(function(location) {
								entry.location += location.name + ' ';
							});
						});
						entry.exhibition = exhibition;
						entry.name = exhibition.name;
					});
				});
				level.sponsors = sponsors;
			});
		});
	});
});
