'use strict';

angular.module('sponsor.model', []).factory('Sponsors', function($common, $database, $exhibitions) {
	var Sponsor = $common.model();
	Sponsor.tableName = 'sponsors';
	Sponsor.fields = {
		'id' : 'text primary key',
		'exhibition' : 'text',
		'level' : 'text',
		'order': 'integer'
	};
	
	Sponsor.prototype.getExhibition = function() {
		var query = 'SELECT exhibitions.id, exhibitions.name, exhibitions.logo, exhibitions.locations FROM exhibitions WHERE exhibitions.id = ?';
		return $database.getItem(query, [this.exhibition],$exhibitions);
	};
	
	Sponsor.prototype.getSponsorLevel = function(){
		var query = 'SELECT * FROM sponsorlevels WHERE sponsorlevels.id = ?';
		return $database.getItem(query,[this.level]);
	};

	

	return Sponsor;
});
