'use strict';

angular.module('sync.files', ['ionic', 'ngCordova']).service('FileUpdate', function($settings, $cordovaFile, $cordovaFileTransfer, $database, $pubsub) {

	var downloadfile = function(url, subfolder) {
		subfolder = subfolder || '.';
		var localPath = cordova.file.applicationDirectory + '/www/img/' + $settings.conferenceId + '/' + subfolder + '/' + url.split('/')[url.split('/').length - 1];
		var targetPath = cordova.file.dataDirectory + $settings.conferenceId + '/' + subfolder + '/' + url.split('/')[url.split('/').length - 1];
		return $cordovaFileTransfer.download(localPath, targetPath, {}, true).then(function(result) {
			return result.toInternalURL();
		}, function(err) {
			console.log(JSON.stringify(err));
			return $cordovaFileTransfer.download(url, targetPath, {}, true).then(function(result) {
				return result.toInternalURL();
			}, function() {
				return false;
			});
		});
	};

	var grabTable = function(table, field) {
		return function() {
			var query;
			if ($settings.isNative) {
				query = 'SELECT id, ' + field + ' FROM ' + table + ' WHERE ' + field + ' NOT LIKE "cdvfile://%" AND ' + field + ' != ""';
			} else {
				query = 'SELECT id, ' + field + ' FROM ' + table + ' WHERE ' + field + ' NOT LIKE "%http%" AND ' + field + ' != ""';
			}
			$database.getItems(query, []).then(function(res) {
				res.forEach(function(item) {
					if ($settings.isNative) {
						var urlPath = item[field].indexOf('http') > -1 ? item[field] : $settings.mediaPath + item[field];
						downloadfile(urlPath, table).then(function(res) {
							if (res !== false) {
								$database.execute('UPDATE ' + table + ' SET ' + field + '=? WHERE id = ?', [res, item.id]);
							}
						});
					} else {
						$database.execute('UPDATE ' + table + ' SET ' + field + '=? WHERE id = ?', [$settings.mediaPath + item[field], item.id]);
					}
				});
				$pubsub.publish('fileSynced:' + table);
			});
		};
	};

	this.init = function() {
		$pubsub.subscribe('maps', grabTable('maps', 'map_file'));
		$pubsub.subscribe('maps', grabTable('maps', 'map_file_thumbnail'));
		$pubsub.subscribe('persons', grabTable('persons', 'vitae_picture'));
		$pubsub.subscribe('exhibitions', grabTable('exhibitions', 'logo'));
		$pubsub.subscribe('medias', grabTable('medias', 'media_file'));
    $pubsub.subscribe('sessions', grabTable('sessions', 'image'));
	};

});
