'use strict';

var events = [];

angular.module('sync.socket', []).provider('SocketProvider', function() {

  function on(event, action) {
    events.push({
      event: event,
      action: action
    });
  }


  this.$get = function() {
    return {
      on: on
    };
  };
}).factory('Socket', function($settings) {
  var socket = io($settings.socketServerUrl);

  var init = function() {
    registerEvents();
  };

  var registerEvents = function() {
    events.forEach(function(event) {
      socket.on(event.event, event.action);
    });
  };

  var removeListener = function (event, action) {
    socket.removeEventListener(event, action);
  };


  var on = function(event, action) {
    socket.on(event, action);
  };

  var emit = function(event, object) {
    socket.emit(event, object);
  };

  var join = function(channel) {
    socket.emit('join', channel);
  };

  var leave = function(channel) {
    socket.emit('leave', channel);
  };


  return {
    init: init,
    on: on,
    emit: emit,
    join: join,
    leave: leave,
    removeListener: removeListener,
  };
});
