'use strict';

angular.module('sync.upload', []).factory('Upload', function($http, $database, $settings, $favorites, Votes, AnalyticEvent) {
	var resourceEndpointUrl = $settings.apiHost + '/conference/' + $settings.conferenceId + '/';
	var resources = {};
	resources[resourceEndpointUrl + 'favorites/'] = $favorites;
	resources[resourceEndpointUrl + 'votes/'] = Votes;
	resources[resourceEndpointUrl + 'analytics/'] = AnalyticEvent;

	function registerResource(Model, url) {
		resources[url] = Model;
	}

	function uploadResources() {
		for (var url in resources) {
			var model = resources[url];
			var query = 'SELECT * FROM ' + model.tableName + ' WHERE uploaded_at is null';
			$database.getItems(query, [], resources[url]).then(uploadResourceTo(url));
		}
	}

	function uploadResourceTo(url) {
		return function(objects) {
			objects.forEach(function(obj) {
				obj.conference = $settings.conferenceId;
				$http.post(url, obj).success(function() {
					obj.uploaded_at = new Date().toISOString();
					obj.save();
				});
			});
		};
	}

	return {
		uploadResources : uploadResources,
		registerResource : registerResource
	};
});
