/**
 * @ngdoc service
 * @name kongressapp.Tags
 * @description
 * Tags Model
 *
 * @param {JUJU} id - ID des Tag's
 * @param {String} title - Name des Tag's
 * @param {String} color - Hintergrundfarbe
 * @param {String} font_color - Schriftfarbe
 * @param {Integer} order - Sortierfeld
 * @param {String} parent - Mögliches Elternteil
 *
 * @author: Michael Junge
 *
 */

(function() {
  'use strict';

  angular.module('tags').factory('Tags', ['$common', '$database',
  function($common, $database) {
    var Tag = new $common.model();
    Tag.tableName = 'tags';
    Tag.fields = {
      'id' : 'text primary key',
      'title' : 'text',
      'color' : 'text',
      'font_color' : 'text',
      'order' : 'integer',
      'parent' : 'text'
    };

    /**
     * @ngdoc function
     * @name kongressapp.Tags.getChildren
     * @description
     *  Gibt eine Liste der Kinder zurück.
     */

    Tag.getChildren = function(id) {
      var query = 'SELECT * FROM tags where parent = ?';
      return $database.getItems(query, [id]);
    };

    return Tag;
  }]);

})();
