'use strict';

angular.module('translations', ['pascalprecht.translate']).config(['$translateProvider',
function($translateProvider) {

  var translations_en = {
    'TITLE' : 'Hello',
    'CHOOSE_LANG' : 'Choose Language',
    'SETTINGS' : 'Settings',
    'CHAIRS' : 'Chairs',
    'SPEAKERS' : 'Speakers',
    'PRESENTATIONS' : 'Presentations',
    'EXHIBITORS' : 'Exhibitors',
    'ABSTRACTS' : 'Abstracts',
    'PERSONS' : 'Persons',
    'SESSIONS' : 'Sessions',
    'CHAIRED_SESSIONS' : 'Chaired sessions',
    'VITAE' : 'Vitae',
    'ISPRESENTED' : 'is presented in',
    'SHOW_ABSTRACT' : 'Show Abstract',
    'FAVORITE_HINT' : 'No favorites selected yet.',
    'DOCUMENTS' : 'Documents',
    'CHAT_HINT' : 'Search for persons to add to your contact list',
    'NOTE_HINT' : 'Write your note here...',
    'NOTES' : 'Notes',
    'PUSH' : 'Enable Push Notifications',
    'VISITBOOTH' : 'Visit us at our booth',
    'SESS_TYPES' : 'Session Types',
    'NEXT' : 'next',
    'BACK' : 'back',
    'QUIT' : 'quit',
    'THXPOLL' : 'Thank You.',
    'UHR' : '',
    'CONTACT_US' : 'Our contact',
    'LOGIN_SUCCESS' : 'Successfully logged in as ',
    'LOGIN_ERROR' : 'Login failed! Please try again!',
    'POLLS' : 'Evaluation',
    'DATE_FORMAT' : 'EEEE d MMM HH:mm ',
    'CHAT_ACTIVATION_BUTTON' : 'Activate Chat',
    'FAVORITE_ADD' : 'Added to favorites',
    'FAVORITE_DEL' : 'Removed from favorites',
    'SEARCH' : 'Search...',
    'IPLANNER_IMPORT' : 'Import from interactive iPlanner',
    'LOGIN_USER_HINT' : 'Username or email',
    'LOGIN_PASS_HINT' : 'Password or token',
    'SIGN_UP' : 'sign up',
    'IMPRINT' : 'Imprint',
    'IMPRINT_THANK' : '<p style=\'text-align:center\'><strong><span style=\'font-size:18px\'>DGU 2015</span></strong><br><strong>Hamburg, 23 - 26 September 2015</strong>',
    'IMPRINT_LEGAL' : '<p style=\'text-align:center\'>This mobile app is powered by<br>documediaS GmbH<br>Günther-Wagner-Allee 13<br>30177 Hannover, Germany<br><a style="text-decoration:underline !important" href="mailto:mobileapp@documedias.com">mobileapp@documedias.com</a></p>',
    'FRAGE' : 'Ask a question',
    'VOTE' : 'Vote for this question',
    'VOTETHX' : 'Thank you for sending your vote',
    'VOTEERR' : 'You sent a vote already',
    'SUBMIT' : 'Submit',
    'NOW_HINT' : 'There are currently no sessions scheduled'

  };

  var translations_de = {
    'TITLE' : 'Hallo',
    'CHOOSE_LANG' : 'Sprache wählen',
    'SETTINGS' : 'Einstellungen',
    'CHAIRS' : 'Vorsitzende',
    'SPEAKERS' : 'Sprecher',
    'PRESENTATIONS' : 'Präsentationen',
    'EXHIBITORS' : 'Aussteller',
    'ABSTRACTS' : 'Abstracts',
    'PERSONS' : 'Personen',
    'SESSIONS' : 'Sitzungen',
    'CHAIRED_SESSIONS' : 'Vorsitz in Sitzung',
    'VITAE' : 'Lebenslauf',
    'ISPRESENTED' : 'wird präsentiert in',
    'SHOW_ABSTRACT' : 'Zum Abstract',
    'FAVORITE_HINT' : 'Dieser Bereich ist für Ihre Favoriten vorgesehen. Sie haben bislang noch keine Favoriten erstellt.',
    'DOCUMENTS' : 'Dokumente',
    'CHAT_HINT' : 'Suchen Sie nach Personen und fügen Sie diese zu Ihrer Kontaktliste hinzu',
    'NOTE_HINT' : 'Hier ist Platz für Ihre Notiz.',
    'NOTES' : 'Notizen',
    'PUSH' : 'Push Nachrichten aktivieren',
    'VISITBOOTH' : 'Besuchen Sie uns an unserem Stand',
    'SESS_TYPES' : 'Sitzungstypen',
    'NEXT' : 'weiter',
    'BACK' : 'zurück',
    'QUIT' : 'verlassen',
    'THXPOLL' : 'Vielen Dank für Ihre Angaben.',
    'UHR' : 'Uhr',
    'CONTACT_US' : 'Unser Kontakt',
    'LOGIN_SUCCESS' : 'Erfolgreich angemeldet als ',
    'LOGIN_ERROR' : 'Eingaben waren falsch',
    'POLLS' : 'Evaluation',
    'CHAT_ACTIVATION_BUTTON' : 'Chat Aktivieren',
    'DATE_FORMAT' : 'EEEE d. MMM HH:mm ',
    'FAVORITE_ADD' : 'Zu Favoriten hinzugefügt',
    'FAVORITE_DEL' : 'Von Favoriten entfernt',
    'SEARCH' : 'Suche...',
    'IPLANNER_IMPORT' : 'Import vom interaktiven iPlanner',
    'LOGIN_USER_HINT' : 'Benutzername oder Email',
    'LOGIN_PASS_HINT' : 'Passwort oder Token',
    'SIGN_UP' : 'Hier registrieren',
    'IMPRINT' : 'Impressum',
    'IMPRINT_THANK' : '<p style=\'text-align:center\'><strong><span style=\'font-size:18px\'>DGU 2015</span></strong><br><strong>Hamburg, 23. - 26. September 2015</strong>',
    'IMPRINT_LEGAL' : '<p style=\'text-align:center\'>This mobile app is powered by<br>documediaS GmbH<br>Günther-Wagner-Allee 13<br>30177 Hannover, Germany<br><a style="text-decoration:underline !important" href="mailto:mobileapp@documedias.com">mobileapp@documedias.com</a></p>',
    'FRAGE' : 'Stellen sie Ihre Frage',
    'VOTE' : 'Stimmen Sie für diese Frage ab',
    'VOTETHX' : 'Vielen dank für Ihre Stimme',
    'VOTEERR' : 'Es ist schon eine Bewertung eingegangen',
    'SUBMIT' : 'Senden',
    'NOW_HINT' : 'Es laufen momentan keine Veranstaltungen'

  };

  $translateProvider.translations('en', translations_en);
  $translateProvider.translations('de', translations_de);
  $translateProvider.registerAvailableLanguageKeys(['en', 'de'], {
    'en_US' : 'en',
    'en_UK' : 'en',
    'de_DE' : 'de',
    'de_CH' : 'de'
  });

  $translateProvider.preferredLanguage('de');
}]);
